package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectCoefficientDO;
import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodProjectCoefficientMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 检测方法分析项目补正系数 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigAssayMethodProjectCoefficientServiceImpl implements ConfigAssayMethodProjectCoefficientService {

    @Resource
    private ConfigAssayMethodProjectCoefficientMapper configAssayMethodProjectCoefficientMapper;

    @Override
    public ConfigAssayMethodProjectCoefficientRespVO createConfigAssayMethodProjectCoefficient(ConfigAssayMethodProjectCoefficientSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodProjectCoefficientDO configAssayMethodProjectCoefficient = BeanUtils.toBean(createReqVO, ConfigAssayMethodProjectCoefficientDO.class);
        configAssayMethodProjectCoefficientMapper.insert(configAssayMethodProjectCoefficient);
        // 返回
        return BeanUtils.toBean(configAssayMethodProjectCoefficient, ConfigAssayMethodProjectCoefficientRespVO.class);
    }

    @Override
    public void updateConfigAssayMethodProjectCoefficient(ConfigAssayMethodProjectCoefficientSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodProjectCoefficientExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodProjectCoefficientDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodProjectCoefficientDO.class);
        configAssayMethodProjectCoefficientMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethodProjectCoefficient(Long id) {
        // 校验存在
        validateConfigAssayMethodProjectCoefficientExists(id);
        // 删除
        configAssayMethodProjectCoefficientMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodProjectCoefficientListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodProjectCoefficientExists(ids);
        // 删除
        configAssayMethodProjectCoefficientMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodProjectCoefficientExists(List<Long> ids) {
        List<ConfigAssayMethodProjectCoefficientDO> list = configAssayMethodProjectCoefficientMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_COEFFICIENT_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodProjectCoefficientExists(Long id) {
        if (configAssayMethodProjectCoefficientMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_COEFFICIENT_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodProjectCoefficientDO getConfigAssayMethodProjectCoefficient(Long id) {
        return configAssayMethodProjectCoefficientMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigAssayMethodProjectCoefficientDO> getConfigAssayMethodProjectCoefficientPage(ConfigAssayMethodProjectCoefficientPageReqVO pageReqVO) {
        return configAssayMethodProjectCoefficientMapper.selectPage(pageReqVO);
    }

}